public int editDistance(String a, String b) 
{
    int m = a.length();
    int n = b.length();
    int substitutionCost = 0;
    
    if(m == 0)
    {
        return n;
    }
    if (n == 0)
    {
        return m;
    }
    
    int[][] d = new int[m+1][n+1];
    
    for(int i = 1; i <= m; i++)
    {
        d[i][0] = i;
    }
    
    for(int j = 1; j <= n; j++)
    {
        d[0][j] = j;
    }
    
    for(int j = 1; j <= n; j++)
    {
        for (int i = 1; i <= m; i++)
        {
            if(a.charAt(i-1) == b.charAt(j-1))
            {
                substitutionCost = 0;
            } 
            else
            {
                substitutionCost = 1;    
            }
            d[i][j] = minimum(d[i-1][j] + 1, d[i][j-1] + 1, d[i-1][j-1] + substitutionCost);
        }
    }
    return d[m][n];
}


public int minimum(int a, int b, int c)
{
    if(a <= b && a <= c)
    {
        return a;
    }
    else if(b <= a && b <= c)
    {
        return b;
    }
    else if(c <= a && c <= b)
    {
        return c;
    }
    return -1;
}