public ListToSort Sort(ListToSort list) {
    quicksort(list, 0, list.Length()-1);
    
    return list;
}

private void quicksort(ListToSort list, int left, int right) {
    if (left < right) {
        int middle = partition(list, left, right);
        quicksort(list, left, middle-1);
        quicksort(list, middle+1, right);
    }
}

private int partition(ListToSort list, int left, int right) {
    int i = left-1, j = right;
    
    while(i < j) {
        while (true) {
            i++;
            if (!list.Smaller(i, right))
                break;
        }
        while (true) {
            j--;
            if (!list.Larger(j, right) || j == 0)
                break;
        }
        if (i < j) list.Swap(i, j);
    }
    
    list.Swap(i, right);
    
    return i;
}