private static boolean isInTree(Node root, Node delete)
    {
        if(root == delete)
        {
            return true;
        }
        if(root.left != null && isInTree(root.left, delete))
        {
           return true; 
        }
        else if (root.right != null && isInTree(root.right, delete))
        {
            return true;
        }       
        else
        {
            return false;
        }
    }
    
    /********** Lösung ***********/
    // Node in parameter represents root of tree
    public static Node delete(Node root, Node delete) {
        if(!isInTree(root, delete))
        {
            return root;
        }
        
        
        //both branches
        if(delete.right != null && delete.left != null)
        {
            Node succ = delete.right;
            
            //find successor
            while(succ.left != null)
            {
                succ = succ.left;
            }
            //take care of child of successor
            //succ has right child, but is not delete.right
            if(succ.right != null && succ != delete.right)
            {
                succ.right.parent = succ.parent;
                succ.parent.left = succ.right;
            }
            //succ has no right child
            else if(succ.right == null && succ != delete.right)
            {   
                succ.parent.left = null;
            }
            
            succ.left = delete.left;
            if(delete.right != succ)
            {
                succ.right = delete.right;
                succ.right.parent = succ;
            }

            succ.parent = delete.parent;
            if(succ.parent != null)
            {
                if(succ.parent.left == delete)
                {
                    succ.parent.left = succ;
                }
                else
                {
                    succ.parent.right = succ;
                }
            }
            //fix left connection
            if(succ.left != null)
            {
                succ.left.parent = succ;
            }
        }
        else
        {
            Node nextNode = null;
            //check if delete has a leave
            if(delete.right == null && delete.left != null)
            {
                nextNode = delete.left;
            }
            else if(delete.right != null && delete.left == null)
            {
                nextNode = delete.right;
            }
            if(nextNode != null)
            {
                nextNode.parent = delete.parent;
            }
            
            // check if delete is root
            if (delete.parent == null)
            {
                return nextNode;
            }
       
            else if(delete.parent.left == delete)
            {
                delete.parent.left = nextNode;
            }
            else
            {
                delete.parent.right = nextNode;
            }
            
        }
        
        return root;
    }