public int editDistance(String a, String b) {
    int lengthA = a.length();
    int lengthB = b.length();
    
    int[][] dp = new int[lengthA + 1][lengthB + 1];
    
    for (int i = 0; i <= lengthA; i++) {
		dp[i][0] = i;
	}
 
	for (int j = 0; j <= lengthB; j++) {
		dp[0][j] = j;
	}
 
	for (int i = 0; i < lengthA; i++) {
		char c1 = a.charAt(i);
		for (int j = 0; j < lengthB; j++) {
			char c2 = b.charAt(j);
 
			if (c1 == c2) {
				dp[i + 1][j + 1] = dp[i][j];
			} else {
				int replace = dp[i][j] + 1;
				int insert = dp[i][j + 1] + 1;
				int delete = dp[i + 1][j] + 1;
 
				int min = replace > insert ? insert : replace;
				min = delete > min ? min : delete;
				dp[i + 1][j + 1] = min;
			}
		}
	}
 
	return dp[lengthA][lengthB];
}