public double knapSack(double[] values, int[] weights, int capacity)
{
	assert values.length == weights.length;
	
	int amount = values.length;
	
	double[][] matrix = new double[amount + 1][capacity + 1];
	for(int i = 0; i < matrix.length; i++)
	{
		for(int j = 0; j < matrix[0].length; j++)
		{
			matrix[i][j] = -1D;
		}
	}
	
	return setAndGet(amount, capacity, matrix, values, weights);
}

public double setAndGet(int amount, int capacity, double[][] matrix, double[] values, int[] weights)
{
	if(amount == 0 || capacity <= 0)
	{
		return 0D;
	}
	
	if(matrix[amount - 1][capacity] == -1)
	{
		matrix[amount - 1][capacity] = setAndGet(
				amount - 1,
				capacity,
				matrix, values, weights);
	}
	
	if(weights[amount - 1] > capacity)
	{
		matrix[amount][capacity] = matrix[amount - 1][capacity];
	}
	else
	{
		if(matrix[amount - 1][capacity - weights[amount - 1]] == -1)
		{
			matrix[amount - 1][capacity - weights[amount - 1]] = setAndGet(
					amount - 1,
					capacity - weights[amount - 1],
					matrix, values, weights);
		}
		
		matrix[amount][capacity] = Math.max(
				matrix[amount - 1][capacity],
				matrix[amount - 1][capacity - weights[amount - 1]] + values[amount - 1]
		);
	}
	
	return matrix[amount][capacity];
}