static int min(int x, int y, int z) {
    if (x <= y && x <= z) {
        return x;
    }
    else if (y <= x && y <= z) {
        return y;
    }
    else {
        return z;
    }
}

public static int editDistance(String a, String b) {
    int m = a.length();
    int n = b.length();
    
    int sub_res[][] = new int[m + 1][n + 1];
    
    for (int i = 0; i <= m; i++) {
        for (int j = 0; j <= n; j++) {
            if (i == 0) {
                sub_res[i][j] = j;
            }
            else if (j == 0) {
                sub_res[i][j] = i;
            }
            else if (a.charAt(i - 1) == b.charAt(j - 1)) {
                sub_res[i][j] = sub_res[i - 1][j - 1];
            }
            else {
                sub_res[i][j] = 1 + min(sub_res[i][j - 1], // Insert
                sub_res[i - 1][j], // Remove
                sub_res[i - 1][j - 1]); // Replace
            }
        }
    }
    
    return sub_res[m][n];
}