public int Calculator(String[] input, IntegerStack s) {
    
    for(int i = 0; i < input.length; i++) {
        if(isNumeric(input[i])){
            int currentNumber = Integer.parseInt(input[i]);
            s.push(currentNumber);
        } else {
            int secondNum = s.pop();
            int firstNum = s.pop();
            String operator = input[i];
            int result = calculate(firstNum, secondNum, operator);
            s.push(result);
        }
    }
    return s.head();
}

private static int calculate(int a, int b, String operator) {
        int result = 0;
        switch(operator){
                case "+": result = a + b;
                break;
                case "-": result = a - b;
                break;
                case "*": result = a * b;
                break;
                case "/": result = Math.round(a/b);
                break;
            }
        return result;
    }
    
    private static boolean isNumeric(String strNum) {
    try {
        int num = Integer.parseInt(strNum);
    } catch (NumberFormatException | NullPointerException nfe) {
        return false;
    }
    return true;
}