public ListToSort Sort(ListToSort list) {
    QuickSort.quicksort(list, 0, list.Length()-1);
    return list;
}

public static class QuickSort{
    
    public static void quicksort(ListToSort A, int l, int r){
        if(l < r){
            int q = partitionHoare(A, l, r);
            quicksort(A, l, q-1);
            quicksort(A, q+1, r);
        }
    }
    private static int partitionHoare(ListToSort A, int l, int r ) {
        int i = l-1;
        int j = r;
        while(i < j){
            do {
                i++;
                
            } while (i < r && (A.Smaller(i, r) || A.Equal(i,r))); //[i] <= A[r]
           do {
               j--;
           } while(l <= j && (A.Larger(j, r) || A.Equal(j, r))); //A[j] >= A[r]
            if(i < j) {
                A.Swap(i, j);
            }
        }
        A.Swap(i, r);
        return i;
    }
}