public class Queue {

    private QueueEntry head;

    public Queue() {
        head = null;
    }

    public boolean emptyqueue() {
        return head == null;
    }

    public String head() {
        return head.getValue();
    }

    public void enqueue(String s) {
        if (head == null) {
            head = new QueueEntry(s);
        } else {
            head.addToEnd(new QueueEntry(s));
        }
    }

    public String dequeue() {
        QueueEntry dequeue = this.head;
        this.head = dequeue.getNext();
        return dequeue.getValue();
    }
    
    private static class QueueEntry {
        private final String value;
        private QueueEntry next;

        QueueEntry(String value) {
            this.value = value;
        }

        void addToEnd(QueueEntry next) {
            if (this.next == null) {
                this.next = next;
            } else {
                this.next.addToEnd(next);
            }
        }

        QueueEntry getNext() {
            return next;
        }

        String getValue() {
            return value;
        }
    }
}